import dcc.doom_base
import dcc.config
import subprocess


class Eureka(dcc.doom_base.WadMap):
    def take_action(self, parsed_args):
        iwad = self.iwad_path(parsed_args.wad)
        pwadpath = self.pwads.joinpath(parsed_args.wad)
        mw = list(pwadpath.glob(
            '*{}*.wad'.format(parsed_args.wad), case_sensitive=False
        ))
        if len(mw) != 1:
            raise Exception(
                f"Unable to guess at main pwad for wad {parsed_args.wad}."
            )

        complevel = self.complevel()
        port = "vanilla"
        if complevel == "9":
            port = "boom"
        if complevel == "11" or complevel == "21":
            port = "mbf"

        subprocess.run(
            ["eureka"] + ["-iwad", iwad] + ["-w", parsed_args.map]
            + ["-p", port] + [mw[0]]
        )
